"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.AbstractApplicationContext = undefined;

var _exception = require("../java/exception");

var _abstractBeanFactory = require("../org.springframework.beans/abstractBeanFactory");

var _annotations = require("./annotations");

var _applicationContextEvent = require("./applicationContextEvent");

var _javax = require("../javax");

var __extends = undefined && undefined.__extends || function () {
    var _extendStatics = function extendStatics(d, b) {
        _extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function (d, b) {
            d.__proto__ = b;
        } || function (d, b) {
            for (var p in b) {
                if (b.hasOwnProperty(p)) d[p] = b[p];
            }
        };
        return _extendStatics(d, b);
    };
    return function (d, b) {
        _extendStatics(d, b);
        function __() {
            this.constructor = d;
        }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();
var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator["throw"](value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : new P(function (resolve) {
                resolve(result.value);
            }).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = undefined && undefined.__generator || function (thisArg, body) {
    var _ = { label: 0, sent: function sent() {
            if (t[0] & 1) throw t[1];return t[1];
        }, trys: [], ops: [] },
        f,
        y,
        t,
        g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
        return this;
    }), g;
    function verb(n) {
        return function (v) {
            return step([n, v]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) {
            try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0:case 1:
                        t = op;break;
                    case 4:
                        _.label++;return { value: op[1], done: false };
                    case 5:
                        _.label++;y = op[1];op = [0];continue;
                    case 7:
                        op = _.ops.pop();_.trys.pop();continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                            _ = 0;continue;
                        }
                        if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                            _.label = op[1];break;
                        }
                        if (op[0] === 6 && _.label < t[1]) {
                            _.label = t[1];t = op;break;
                        }
                        if (t && _.label < t[2]) {
                            _.label = t[2];_.ops.push(op);break;
                        }
                        if (t[2]) _.ops.pop();
                        _.trys.pop();continue;
                }
                op = body.call(thisArg, _);
            } catch (e) {
                op = [6, e];y = 0;
            } finally {
                f = t = 0;
            }
        }if (op[0] & 5) throw op[1];return { value: op[0] ? op[1] : void 0, done: true };
    }
};

//
// Context is a Ioc container with event system
//
var PFX = "[ABSTRACT APPLICATION CONTEXT]:";
var AbstractApplicationContext = /** @class */function (_super) {
    __extends(AbstractApplicationContext, _super);
    function AbstractApplicationContext() {
        var _this = _super.call(this) || this;
        _this.parentBeanFactory = null;
        return _this;
    }
    AbstractApplicationContext.prototype.publishEvent = function (event) {
        if (this.beansMap) {
            this.beansMap.forEach(function (bean) {
                if (Reflect.hasMetadata(_annotations.eventsToken, bean.constructor)) {
                    var eventListenerRecords = Reflect.getMetadata(_annotations.eventsToken, bean.constructor);
                    eventListenerRecords.forEach(function (record) {
                        if (event instanceof record.eventClass) {
                            bean[record.key].call(bean, event);
                        }
                    });
                }
            });
        } else {
            throw new _exception.Exception(PFX + " could not publish event - context not started");
        }
        // broadcast to parent contexts
        if (this.parentBeanFactory && this.parentBeanFactory.isRunning()) {
            this.parentBeanFactory.publishEvent(event);
        }
    };
    //
    // ILifecycle implementation
    //
    AbstractApplicationContext.prototype.load = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        return [4 /*yield*/, AbstractApplicationContext.loadResources()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    AbstractApplicationContext.prototype.start = function () {
        _super.prototype.start.call(this);
        this.publishEvent(new _applicationContextEvent.ApplicationContextStartEvent(this));
    };
    AbstractApplicationContext.prototype.stop = function () {
        this.publishEvent(new _applicationContextEvent.ApplicationContextStopEvent(this));
        _super.prototype.stop.call(this);
    };
    AbstractApplicationContext.prototype.close = function () {
        _super.prototype.close.call(this);
    };
    //
    // Implementation
    //
    AbstractApplicationContext.loadResources = function () {
        return __awaiter(this, void 0, void 0, function () {
            var resources, i, resource, response, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        resources = Reflect.getMetadata(_javax.resourceDependenciesToken, _javax.ResourceHolder) || [];
                        if (!(Object.keys(_abstractBeanFactory.AbstractBeanFactory.resources).length === 0)) return [3 /*break*/, 5];
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < resources.length)) return [3 /*break*/, 5];
                        resource = resources[i];
                        return [4 /*yield*/, fetch(resource.url)];
                    case 2:
                        response = _a.sent();
                        return [4 /*yield*/, response.json()];
                    case 3:
                        data = _a.sent();
                        _abstractBeanFactory.AbstractBeanFactory.resources[resource.url] = data;
                        _a.label = 4;
                    case 4:
                        ++i;
                        return [3 /*break*/, 1];
                    case 5:
                        return [2 /*return*/];
                }
            });
        });
    };
    return AbstractApplicationContext;
}(_abstractBeanFactory.AbstractBeanFactory);
exports.AbstractApplicationContext = AbstractApplicationContext;
//# sourceMappingURL=abstractApplicationContext.js.map