import { IApplicationContextAware, IApplicationContext } from "./applicationContext";
/**
 * Application context holder.
 * Singleton.
 * @remark https://syncope.apache.org/apidocs/2.0/org/apache/syncope/core/spring/ApplicationContextProvider.html
 */
export declare class ApplicationContextProvider implements IApplicationContextAware {
    context: IApplicationContext;
    private static instance;
    /**
     * Get application context provider singleton object
     */
    static get(): ApplicationContextProvider;
    /**
     * Get application context from holder
     */
    getApplicationContext(): IApplicationContext;
    /**
     * Set application context to hold on
     * @param context - context to keep
     */
    setApplicationContext(context: IApplicationContext): void;
}
