import { AbstractApplicationContext } from "./abstractApplicationContext";
import { IApplicationContextLoader } from "./applicationContextLoader";
/**
 * Application context loaded from remote json configuration file (like xml in spring)
 * @remark https://docs.spring.io/spring-framework/docs/current/javadoc-api/org/springframework/context/support/ClassPathXmlApplicationContext.html
 */
export declare class JsonUrlApplicationContext extends AbstractApplicationContext implements IApplicationContextLoader {
    private url;
    private schema;
    constructor(url: string);
    /**
     * Load context from url.
     */
    load(): Promise<void>;
    /**
     * Load beans configuration from context file.
     * @param debug - show beans definition to console
     */
    configureBeansDefinitions(debug: boolean): void;
    /**
     * Instantiate beans specified in context file.
     * @param debug - show beans instantiated to console
     */
    startSchemaBeans(debug: boolean): Promise<void>;
}
