export declare const testsToken: unique symbol;
export declare const asyncTestsToken: unique symbol;
export declare const spiesToken: unique symbol;
export declare const spiesValuesToken: unique symbol;
export declare const spiesOnGetToken: unique symbol;
/**
 * Mark bean method as test.
 * @remark https://junit.org/junit4/javadoc/4.12/org/junit/Test.html
 */
export declare function Test(target: any, key: any, descriptor: any): void;
/**
 * Mark bean method as async test.
 * @remark https://junit.org/junit4/javadoc/4.12/org/junit/Test.html
 */
export declare function AsyncTest(target: any, key: any, descriptor: any): void;
/**
 * Spy for bean method.
 */
export declare function Spy(target: any, key: any, descriptor: any): void;
/**
 * Spy for bean getter.
 */
export declare function SpyOnGet(target: any, key: any, descriptor: any): void;
