import { AbstractApplicationContext } from "../org.springframework.context";
/**
 * Register all test in bean.
 * @param token - bean token.
 * @param type - bean class.
 * @param contextGetter - getter of context from retrieve bean.
 */
export declare function registerAllTest(token: Symbol, type: any, contextGetter: () => AbstractApplicationContext): void;
/**
 * Init annotated mocks in bean.
 * @param token - bean token.
 * @param type - bean class.
 * @param context - context from retrieve bean.
 */
export declare function initMocks(token: Symbol, type: any, context: AbstractApplicationContext): Promise<void>;
/**
 * Deinit mocks in bean.
 * @param token - bean token.
 * @param type - bean class.
 * @param context - context from retrieve bean.
 */
export declare function deinitMocks(token: Symbol, type: any, context: AbstractApplicationContext): Promise<void>;
