import { ITransaction, ETransactionStatus, TTransactionOperation } from "../javax/transaction";
/**
 * Abstract transaction.
 * Basic implementation for Transaction interface.
 * @remark https://tinkerpop.apache.org/javadocs/3.3.0/full/org/apache/tinkerpop/gremlin/structure/util/AbstractTransaction.html
 */
export declare class AbstractTransaction implements ITransaction {
    protected commitingOperations: TTransactionOperation[];
    private status;
    constructor();
    commit(operations: TTransactionOperation[]): Promise<void>;
    rollback(operations: TTransactionOperation[]): Promise<void>;
    getStatus(): ETransactionStatus;
}
